
#!/bin/bash

# Programa fet pel grup 3a de 4t de biologia del curs 2012-2013  de la Universitat Pompeu Fabra
# Contacte: gloria.clua01@estudian.upf.edu, julia.domingo01@estudiant.upf.edu


##Per a executar aquest programa cal prèviament haver creat la llibreria de selenoproteïnes (amb el programa llibreria.bash) i poder accedir al genoma en el qual volem anotar les selenoproteïnes (el podem trobar en /cursos/BI/genomes/project_2013/Chrysemys_picta_bellii/genome.fa)


#####BLAST#####

echo
echo -e "\033[1;34mEn quina query vols que es realitzi el Blast? (Copia exactament: human , gallus o danio)\033[0m"; 
echo

read specie

##Primer hem de crear un directori per a cada selenoproteïna i un subdirectori blast per a cadascuna.

for selenoprotein  in `grep 'SPP' selenoproteinsdb_$specie.fa | cut -c2- | cut -f1 | sort -u`; do
    mkdir -p ./$selenoprotein/blast
done;

##Realitzem el blast en si.

export PATH=/cursos/BI/soft/ncbiblast/blast-2.2.13/bin/:$PATH
cp /cursos/BI/soft/ncbiblast/blast-2.2.13/bin/blastall ~/
export PATH=/cursos/BI/bin:$PATH

echo
echo -e "\033[1;34mEsperant els resultats del Blast...\033[0m";
echo

if [ ! -f ./$selenoprotein/blast/$selenoprotein.tblastn ]; then

blastall -p tblastn -i ./selenoproteinsdb_$specie.fa -d /cursos/BI/genomes/project_2013/Chrysemys_picta_bellii/genome.fa -o /homes/users/U63744/Treball_BI/blastoutput_$specie -e 1e-5

blastall -p tblastn -i ./selenoproteinsdb_$specie.fa -d /cursos/BI/genomes/project_2013/Chrysemys_picta_bellii/genome.fa -o /homes/users/U63744/Treball_BI/blastoutputm8_$specie -e 1e-5 -m8

fi; 

echo -e "\033[1;34mEt mostrem el resultat del blast\033[0m";

head -20 ./blastoutputm8_$specie


##Els hits estadísticament significatius de cada selenoproteina els guardem en diferents fitxers cada un dins d'un directori corresponent a cada selenoproteina anomenat blast:


for selenoprotein in `grep 'SPP' selenoproteinsdb_$specie.tab | cut -c2- | cut -f 1 | sort -u`; do
  for hit in `grep 'gi|' blastoutputm8_$specie | cut -f1 | sort -u`; do
     if [ "$hit" == "$selenoprotein" ]; then
        grep $hit blastoutputm8_$specie > ./$selenoprotein/blast/${hit}.tblastn;
     fi;
  done;
done;

##Els hits significatius de cada selenoproteïna han estat guardats en /$selenoprotein/blast/$hit.tblastn