#!/bin/bash


## Programa fet pel grup 3a de 4t de biologia del curs 2012-2013  de la Universitat Pompeu Fabra
## Contacte: julia.domingo01@estudiant.upf.edu, gloria.clua01@estudiant.upf.edu

echo -e "\033[1;34mHola usuari, a continuació iniciarem el programa JGPC_Automatitzat! D'aquesta manera es podran obtenir anotacions de les selenoproteïnes actualment descrites en el genoma de Chrysemys picta belli. Per quina espècie vols que es realitzi el programa automatitzat?\033[0m";

echo -e "\033[1;34mCopia exactament: human , gallus o danio\033[0m";
echo

read specie


###"El primer pas consisteix en l'extracció de la regió genòmica que potencialment conté el gen que estem buscant. Amb aquest objectiu farem anar uns programes que formen part d'un software anomenat exonerate. Cal tenir instal·lats els següents programes; fastaseqfromGFF.pl i canvi.pl. També has de tenir el resultat del blast en la carpeta "Llibreria_selenoproteins" i una carpeta generada amb el nom de cada selenoproteïna on es guardaran tots els documents resultants en córrer el programa separats en diferents carpetes internes.A més cal poder accedir al genoma de c.picta que està guardat en /cursos/BI/genomes/project_2013/Chrysemys_picta_bellii/genome.fa.  

export PATH=/cursos/BI/bin:$PATH
export PATH=/cursos/BI/soft/exonerate/i386/bin:$PATH
export WISECONFIGDIR=/cursos/BI/soft/wise-2.2.0/wisecfg
cp /cursos/BI/bin/ncbiblast/.ncbirc ~/
export PATH=/cursos/BI/bin/ncbiblast/bin:$PATH

### Fastaindex: et crea el document genome.index que serà la base de dades que requereix el fastafetch pel seu funcionament.

if [ ! -f ./genome.index ]; then
	fastaindex /cursos/BI/genomes/project_2013/Chrysemys_picta_bellii/genome.fa ./genome.index;
fi;


#####EXONERATE#####

echo -e "\033[1;34mExonerate\033[0m";
echo -e "\033[1mA partir del document blastoutput_$specie, s'estimen les posicions cromosòmiques on comença i acaba la regió sencera que ocupa aquest gen i s'extreu la regió cromosòmica on està en un fitxer FASTA.\033[0m";

### Inici del programa

for selenoprotein in `grep 'SPP' ./selenoproteinsdb_$specie.tab | cut -c2- | cut -f1 | sort -u`; do
for scaffold in `grep 'gi|' ./$selenoprotein/blast/$selenoprotein.tblastn | cut -f2 |  sort -u`; do

	echo "$selenoprotein, $scaffold";
	echo

	scaf=`echo $scaffold|cut -f4 -d"|"`

### Programes per executar exonerate

### Fastafetch: et localitza la regió cromosòmica dins el genoma de C.picta on es localitzen els hits amb una valoració positiva.

	mkdir -p ./$selenoprotein/fastafetch/
	fastafetch /cursos/BI/genomes/project_2013/Chrysemys_picta_bellii/genome.fa genome.index $scaffold > "./$selenoprotein/fastafetch/${selenoprotein}.${scaf}.db"

	echo -e "\033[1;34mS'ha obtingut el resultat de fastafetch\033[0m";

### Fastasubseq: et permet localitzar i extendre la regió genòmica que possiblement codifica per la proteïna cercada.

mkdir -p ./$selenoprotein/fastasubseq/
        column9=`grep $scaf ~/Treball_BI/$selenoprotein/blast/$selenoprotein.tblastn | cut -f9 | sort -n | sed -n 1p`;
        column10=`grep $scaf ~/Treball_BI/$selenoprotein/blast/$selenoprotein.tblastn | cut -f10 | sort -n | sed -n 1p`;

        if [ "$column9" -lt "$column10" ];
            then
                start=$(($column9 - 20000));
		if [ $start -le 0 ]
                then
                    $start=0;
                else
                    end=`grep $scaf ~/Treball_BI/$selenoprotein/blast/$selenoprotein.tblastn | cut -f10 | sort -r | sed -n 1p`;
                    length=$(($end - $start + 20000));
                fi;

        else
                start=$(($column10 - 20000));
		if [ $start -le 0 ]
                then
                    $start=0;
                else
                    end=`grep $scaf ~/Treball_BI/$selenoprotein/blast/$selenoprotein.tblastn | cut -f9 | sort -r | sed -n 1p`;
                    length=$(($end - $start + 20000));
		    fi;

        fi;



	fastasubseq ./$selenoprotein/fastafetch/$selenoprotein.$scaf.db $start $length > ./$selenoprotein/fastasubseq/$selenoprotein.$scaf.subseq.fa 


###Exonerate

	mkdir -p ./$selenoprotein/exonerate

        ###Per si al fasta de sequencia hi ha Us, cal substituir-les per X, però només un cop!

        if [ "$int_UX"=="0" ]; then
        ./canvi.pl < ./Llibreria_selenoproteins_$specie/"${selenoprotein}.fa" > ./$selenoprotein/canviXU.fa;
        int_UX="1";
        fi;


	exonerate -m p2g --showtargetgff -q "./$selenoprotein/canviXU.fa" -t ./$selenoprotein/fastasubseq/"${selenoprotein}.${scaf}.subseq.fa" > ./$selenoprotein/exonerate/"${selenoprotein}.${scaf}.exonerate.gff"



	###El programa fastaseqfromGFF.pl el farem anar en dos passos, en un primer pas obtindrem en un fitxer apart \
	###l'anotació en GFF del programa exonerate, i en un segon pas extreurem la seqüència.

	echo
	echo -e "\033[1;34mS'ha obtingut el fitxer gff\033[0m";
	echo

###FastaseqfromGFF.pl (extraccio de cDNA)

###Fastatranslate, de cDNA a proteina

export PATH=/cursos/BI/soft/exonerate/i386/bin:$PATH

        echo
        echo -e "\033[1;34mS'esta duent a terme el programa Fastatranslate que ens traduira el cDNA a proteina\033[0m";
        echo

    ##Per extreure el cDNA i traduir-lo a proteïnes

		echo -e "\033[1;34mPreparant i executant per t_coffee:\033[0m";

		exon=`grep -w exon ./$selenoprotein/exonerate/${selenoprotein}.${scaf}.exonerate.gff`
		echo "$exon" > ./$selenoprotein/exonerate/${selenoprotein}.${scaf}.exonerate.exon.gff
                if [ "$exon" != "" ]; then

                        mkdir -p ./$selenoprotein/cDNA

                        fastaseqfromGFF.pl ./${selenoprotein}/fastasubseq/"${selenoprotein}.${scaf}.subseq.fa" ./${selenoprotein}/exonerate/"${selenoprotein}.${scaf}.exonerate.exon.gff" > ./${selenoprotein}/cDNA/${selenoprotein}.${scaf}.cDNA


                        mkdir -p ./$selenoprotein/proteina
                        fastatranslate -F 1 "./$selenoprotein/cDNA/${selenoprotein}.${scaf}.cDNA" > "./$selenoprotein/proteina/${selenoprotein}.${scaf}.translate.fa"

                fi

	echo


#####TCOFFEE#####

	mkdir -p ./$selenoprotein/t_coffee

	t_coffee "./Llibreria_selenoproteins_$specie/${selenoprotein}.fa" "./$selenoprotein/proteina/${selenoprotein}.${scaf}.translate.fa" > ./$selenoprotein/t_coffee/"${selenoprotein}.${scaf}.aln"

mv *html ./$selenoprotein/t_coffee
mv *aln ./$selenoprotein/t_coffee


#####NCBI non-redundant#####

echo -e "\033[1:34m Cerca de proteïnes similars en la base de dades de proteïnes no redundant d'NCBI\033[0m"

mkdir -p ./$selenoprotein/NCBI

export PATH=/cursos/BI/bin/netblast/bin:$PATH
export PATH=/cursos/BI/bin/ncbiblast/bin:$PATH
cp /cursos/BI/bin/ncbiblast/.ncbirc ~/


blastall -p blastp -i "./$selenoprotein/proteina/${selenoprotein}.${scaf}.translate.fa" -d /cursos/BI/soft/selenoprofiles_2_installation/libraries/nr -o ./$selenoprotein/NCBI/${selenoprotein}.${scaf}.ncbi 

done
done