
#!/bin/bash

# Programa fet pel grup 3a de 4t de biologia del curs 2012-2013  de la Universitat Pompeu Fabra
# Contacte: julia.domingo01@estudiant.upf.edu, gloria.clua01@estudiant.upf.edu 

#####SelSearch#####

##Consisteix en anotar una selenoproteïna de manera maunal però concatenant tots els programes requerits en un sol programa, d'aquesta manera es podran repetir o repassar aquelles selenoproteïnes que hagin sortit subtoses o calgui retocar la seva cerca.

echo
echo -e "\033[1;34mHola usuari, a continuació realitzarem el programa SelSearch. L'objectiu és anotar una selenoproteïna de manera manual en el genoma de Chrysemys picta bellii. Et recomanem que obris una altra pestanya amb el Luke obert per realitzar alguna modificació manual si fos convenient. Doncs comencem!\033[0m"

### Fastaindex

export PATH=/cursos/BI/bin:$PATH  

### Fastaindex: et crea el document genome.index que serà la base de dades que requereix el fastafetch pel seu funcionament.

if [ ! -f ./genome.index ]; then
        fastaindex /cursos/BI/genomes/project_2013/Chrysemys_picta_bellii/genome.fa ./genome.index;
fi;


### Fastafetch d'un selenoproteïna d'interès

### Escullim la selenoproteïna que volem cercar en el nostre organisme

echo -e "\033[1mQuina selenoproteïna volem cercar en el nostre genoma? Primer indica'ns l'espècie que t'interessa (copia exactament una de les tres)\033[0m"
echo
echo -e "\033[1mhuman gallus danio\033[0m"
echo
read specie
echo

echo -e "\033[1mQuina selenoproteïna vols cercar exactament?\033[0m"
ls ./Llibreria_selenoproteins_$specie/
echo

echo -e "\033[1mIntrodueix el nombre exacte de la selenoproteïna (copia el nom que comença per "SPP" i l'enganxes directament a continuació):  \033[0m"
read selenoprotein

mkdir -p ./SelSearch/$selenoprotein/blast

##Realitzem el blast en si.

export PATH=/cursos/BI/bin/ncbiblast/bin:$PATH
cp /cursos/BI/bin/ncbiblast/.ncbirc ~/
export PATH=/cursos/BI/bin:$PATH

echo
echo -e "\033[1;34mEsperant els resultats del Blast...requereix aproximadament uns 3 minuts\033[0m";
echo

echo -e "\033[1mQuin e-value consideres significatiu?. Copia directament: 1e-5 , 1e-4 , 1e-3 , 1e-2 , 1e-1\033[0m";
read evalue

echo
echo 

#blastall -p tblastn -i ./Llibreria_selenoproteins_$specie/$selenoprotein.fa -d /cursos/BI/genomes/project_2013/Chrysemys_picta_bellii/genome.fa -o /homes/users/U63744/Treball_BI/SelSearch/$selenoprotein/blast/blastoutput_${selenoprotein}_$specie -e $evalue

blastall -p tblastn -i ./Llibreria_selenoproteins_$specie/$selenoprotein.fa -d /cursos/BI/genomes/project_2013/Chrysemys_picta_bellii/genome.fa -o /homes/users/U63744/Treball_BI/SelSearch/$selenoprotein/blast/blastoutputm8_${selenoprotein}_$specie -e ${evalue} -m8

echo
echo -e "\033[1;34mEt mostrem el resultat del blast\033[0m";
echo -e "\033[1m Quin d'aquests hits resultants del Blast creus que es correspon a la selenoproteïna que busques? \033[0m"
echo -e "\033[1m Copia directament la regió escollida, amb aquest format gi|...|gb|...| :  \033[0m"
echo
more ~/Treball_BI/SelSearch/$selenoprotein/blast/blastoutputm8_${selenoprotein}_$specie
echo
echo
read scaffold
echo
echo

scaf=`echo $scaffold|cut -f4 -d"|"`

mkdir -p ./SelSearch/$selenoprotein/fastafetch/

fastafetch /cursos/BI/genomes/project_2013/Chrysemys_picta_bellii/genome.fa genome.index $scaffold > ./SelSearch/$selenoprotein/fastafetch/${selenoprotein}.${scaf}.db


###Fastasubseq, per realitzar el fastasubseq és necessari modificar la regió genòmica. A partir d'aquestes posicions cromosòmiques, estimeu les posicions cromosòmiques on comença i acaba la regió sencera que ocupa aquest gen i feu-les anar per extreure la regió cromosomica on està en un fitxer FASTA apart mitjançant el programa fastasubseq (què es part dels programes que acompanyen exonerate)

echo -e "\033[1mAra posarem en marxa el programa Fastasubseq ...\033[0m"
echo
more ~/Treball_BI/SelSearch/$selenoprotein/blast/blastoutputm8_${selenoprotein}_$specie
echo
echo
echo -e "\033[1mPrimer localitza la posició cromosòmica on comença la regió que ocupa aquest gen. Per poder analitzar la seqüència acuradament cal que extenguis la posició cromosòmica inicial uns 20000 nucleòtids. D'aquesta manera t'assegures que estàs agafant tot el gen. Si l'inici es troba pròxim al començament de l'scaffold (a una llargada menor a 20000nt) posa 1 com a inici de la seqüència :  \033[0m"
echo
read inici
echo
echo -e "\033[1mIntrodueix la longitut de la seqüència, extén uns 20000 nucleotids la posició cromosòmica final tal i com has fet en el pas anterior:  \033[0m"
echo
read longitut
echo

mkdir -p ./SelSearch/$selenoprotein/fastasubseq/

fastasubseq ./SelSearch/$selenoprotein/fastafetch/${selenoprotein}.${scaf}.db $inici $longitut > ./SelSearch/$selenoprotein/fastasubseq/${selenoprotein}.${scaf}.subseq.fa 2> error.temp

error=`cat error.temp | egrep "Subsequence must end before end of"`;
if [ "$error" != "" ]; then
echo -e "\033[1mLa longitut indicada és més gran que la seqüència de l'scaffold, en aquest cas el programa detecta un error. Cal que redueixis 10000 nucleòtids. Torna a indicar la longitut:\033[0m"
        echo
        read longitut
        echo
fastasubseq ./SelSearch/$selenoprotein/fastafetch/${selenoprotein}.${scaf}.db $inici $longitut > ./SelSearch/$selenoprotein/fastasubseq/${selenoprotein}.${scaf}.subseq.fa 2> error1.temp
fi;

error1=`cat error1.temp | egrep "Subsequence must end before end of"`;
if [ "$error1" != "" ]; then
echo -e "\033[1mLa longitut indicada continua essent més gran que la seqüència de l'scaffold, en aquest cas el programa detecta un error. Cal que tornis a indicar la longitut però considerant l'últim nucleòtid mostrat pel blast com a final de seqüència:\033[0m"
	echo
	read longitut
	echo

	fastasubseq ./SelSearch/$selenoprotein/fastafetch/${selenoprotein}.${scaf}.db $inici $longitut > ./SelSearch/$selenoprotein/fastasubseq/${selenoprotein}.${scaf}.subseq.fa
fi;


echo -e "\033[1mEt mostrem la seqüència seleccionada. Si estàs d'acord pressiona Q per sortir del more\033[0m"

head ./SelSearch/$selenoprotein/fastasubseq/${selenoprotein}.${scaf}.subseq.fa
echo
echo
read -p "A continuació tecleja [Enter] per continuar"

echo

###A partir de la selenoproteïna escollida i de la regió genòmica que hem extret anteriorment generarem una anotació del gen que dóna lloc a aquesta proteina mitjançant el programa exonerate. El directori /exonerate guardat en /cursos/BI/bin conté el programa fastaseqfromGFF.pl, essencial per poder realitzar el programa Exonerate.\033[0m" 

###Exonerate

export PATH=/cursos/BI/soft/exonerate/i386/bin:$PATH

mkdir -p ./SelSearch/$selenoprotein/exonerate

echo -e "\033[1;34mExonerate\033[0m"
echo

./canvi.pl < ./Llibreria_selenoproteins_$specie/"${selenoprotein}.fa" > ./SelSearch/$selenoprotein/canviXU.fa;

exonerate -m p2g --exhaustive yes --showtargetgff -q ./SelSearch/$selenoprotein/canviXU.fa -t ./SelSearch/$selenoprotein/fastasubseq/${selenoprotein}.${scaf}.subseq.fa > ./SelSearch/$selenoprotein/exonerate/${selenoprotein}.${scaf}.exonerate.gff

more  ./SelSearch/$selenoprotein/exonerate/${selenoprotein}.${scaf}.exonerate.gff

read -p "Si no estàs content amb el resultat obtingut bé perquè no t'ha alineat la selenocisteïna o perquè necessites allargar la seqüència, pots modificar l'inici i la longitud de la seqüència per realitzar un altre Exonerate un cop més. Vols realitxar aquesta modificació? Copia SI (en majúscules) en cas afirmatiu si no, copia NO (en majúscules) per continuar;    "

if [[ "$REPLY" == "SI" ]]; then
echo -e "\033[1mObre el resultat de la taula del blast ./SelSearch/$selenoprotein/blast/blastoutputm8_$selenoprotein_$specie i allarga l'inici i la longitud per a poder tornar a realitzar l'Exonerate. Indica'ns el nou inici: \033[0m" 
read inici
echo -e "\033[1m Indica'ns la nova longitut desitjada: \033[0m"
read longitut

fastasubseq ./SelSearch/$selenoprotein/fastafetch/${selenoprotein}.${scaf}.db $inici $longitut > ./SelSearch/$selenoprotein/fastasubseq/$selenoprotein.${scaffold}.subseq.fa

echo -en "\033[1m Et mostrem la seqüència seleccionada. Si estàs d'acord pressiona Q per sortir del more\033[0m"
echo
read -p "Tecleja [Enter] per conitnuar"
more  ./SelSearch/$selenoprotein/fastasubseq/$selenoprotein.$scaffold.subseq.fa
echo

exonerate -m p2g --exhaustive yes --showtargetgff -q ./SelSearch/$selenoprotein/canviXU.fa -t ./SelSearch/$selenoprotein/fastasubseq/${selenoprotein}.${scaf}.subseq.fa > ./SelSearch/$selenoprotein/exonerate/${selenoprotein}.${scaf}.exonerate.gff

more  ./SelSearch/$selenoprotein/exonerate/${selenoprotein}.${scaf}.exonerate.gff

fi;
echo
echo
echo -e "\033[1m A continuació guardarem els exons en un document per separat anomenat ${selenoprotein}.${scaf}.exonerate.exon.gff. El trobaràs dins el directori ./SelSearch/exonerate\033[0m"

echo
echo -e "\033[1mObtenint el cDNA\033[0m"
echo

###El programa fastaseqfromGFF.pl el farem anar en dos passos, en un primer pas obtindrem en un fitxer apart l'anotació en GFF del programa exonerate, i en un segon pas extreurem la seqüència.

###FastaseqfromGFF.pl (extraccio de cDNA)

mkdir -p ./SelSearch/$selenoprotein/cDNA

export PATH=/cursos/BI/bin:$PATH
export WISECONFIGDIR=/cursos/BI/soft/wise-2.2.0/wisecfg

exon=`grep -w exon ./SelSearch/$selenoprotein/exonerate/${selenoprotein}.${scaf}.exonerate.gff`
echo "$exon" > "./SelSearch/$selenoprotein/exonerate/${selenoprotein}.${scaf}.exonerate.exon.gff";

if [ "$exon" != "" ]; then

	fastaseqfromGFF.pl ./SelSearch/${selenoprotein}/fastasubseq/"${selenoprotein}.${scaf}.subseq.fa" ./SelSearch/${selenoprotein}/exonerate/"${selenoprotein}.${scaf}.exonerate.exon.gff" > ./SelSearch/${selenoprotein}/cDNA/${selenoprotein}.${scaf}.cDNA

fi;

###Fastatranslate, de cDNA a proteina

echo
echo -e "\033[1mS'està duent a terme el programa Fastatranslate que ens traduirà el cDNA a proteïna\033[0m"
echo

mkdir -p ./SelSearch/$selenoprotein/proteina

fastatranslate -F 1 "./SelSearch/$selenoprotein/cDNA/${selenoprotein}.${scaf}.cDNA" > "./SelSearch/$selenoprotein/proteina/${selenoprotein}.${scaf}.translate.fa"
echo

echo -e "\033[1mS'ha creat un fitxer amb la seqüència aminoacídica de la proteïna predita a "./SelSearch/proteina/${selenoprotein}.${scaf}.traslate.fa". Obre l'arxiu en la pestanya que prèviament has obert i escull un dels 6 marcs de lectura que et mostra el document. Deixa'l en format fasta i guarda teclejant C-X C-S i per sortir C-X C-C. Si tens dubtes del patró a escollir pots mirar el resultat de l'exonerate /SelSearch/$selenoprotein/exonerate/${selenoprotein}.${scaf}.exonerate.gff.\033[0m"


###T_coffee

echo
echo -e "\033[1mRealitzant t_coffee. Si t'indica que escriguis en email pots teclejar Enter per continuar.\033[0m"
echo

mkdir -p  ./SelSearch/$selenoprotein/t_coffee

t_coffee ./Llibreria_selenoproteins_$specie/${selenoprotein}.fa ./SelSearch/$selenoprotein/proteina/${selenoprotein}.${scaf}.translate.fa > ./SelSearch/$selenoprotein/t_coffee/"${selenoprotein}.${scaf}.aln"

mv *html ./SelSearch/$selenoprotein/t_coffee 
mv *aln ./SelSearch/$selenoprotein/t_coffee  

###Hauríeu de poder observar que l'anotació generada anteriorment dóna lloc exactament a la mateixa proteïna a partir de la qual hem buscat l'anotació del gen que la codifica. Observeu també la forma en què TCOFFEE mostra l'alineament de la selenocisteina.

###Comparar el teu hit amb la NRdatabase per comporvar si existeix alguna proteina coneguda codificada dins els teu hit


echo -e "\033[1mComparant el hit resultant amb la base de dades no redundant d'NCBI.\033[0m"

mkdir -p ./SelSearch/$selenoprotein/NCBIex

export PATH=/cursos/BI/bin/netblast/bin:$PATH
export PATH=/cursos/BI/bin/ncbiblast/bin:$PATH
cp /cursos/BI/bin/ncbiblast/.ncbirc ~/

blastall -p blastp -i "./SelSearch/$selenoprotein/proteina/${selenoprotein}.${scaf}.translate.fa" -d /cursos/BI/soft/selenoprofiles_2_installation/libraries/nr -o ./SelSearch/$selenoprotein/NCBIex/${selenoprotein}.${scaf}.ncbi


###Anàlogament podem realitzar el programa Genewise per confirmar els nostres resultats. A partir de la selenoproteina escollida i de la regio genòmica que hem extret anteriorment del resultat del blast, generarem una anotació del gen que dóna lloc a aquesta proteïna mitjançant el programa GeneWise.

echo -e "\033[1mVols realitzar el programa Genewise? Aquest et permetrà comporvar els resultats obtinguts amb Exonerat per confirmar la teva cerca. Indica SI o NO (en majúsucles)    \033[0m" 
read resposta

if [ "$resposta" = "SI" ]; then
echo
echo -e "\033[1mRealitzant el Genewise si la teva seqüència és invertida, cal que escriguis -trev a continuació. Si és directa tecleja Enter per continuar  \033[0m"
read trev
echo

mkdir -p ./SelSearch/$selenoprotein/genewise

export PATH=/cursos/BI/bin:$PATH
export WISECONFIGDIR=/cursos/BI/soft/wise-2.2.0/wisecfg

echo
genewise -pep -pretty -cdna -gff ./Llibreria_selenoproteins_$specie/${selenoprotein}.fa ./SelSearch/${selenoprotein}/fastasubseq/${selenoprotein}.${scaf}.subseq.fa $trev > ./SelSearch/$selenoprotein/genewise/${selenoprotein}.${scaf}.genewise.gff

echo
echo -e "\033[1mObtenint seqüència peptídica a partir del fitxar obtingut en format .gff. Cal tenir el programa GFFtoFA.pl instal·lat en el directori ./Treball_BI. Si ja teniu el programa guardat en la carpeta Treball_BI podeu prémer a l'enter directament\033[0m"
read si

chmod u+x ./GFFtoFA.pl

mkdir -p ./SelSearch/$selenoprotein/genewise_proteina/

./GFFtoFA.pl < ./SelSearch/$selenoprotein/genewise/$selenoprotein.${scaf}.genewise.gff > ./SelSearch/$selenoprotein/genewise_proteina/$selenoprotein.${scaf}.genewise.proteina.fa

###Igual que amb el resultat de l'Exonerate, també realitzem un Tcoffee del resultat de Genewise

echo
echo -e "\033[1mRealitzant el t_coffee\033[0m"
echo
mkdir -p ./SelSearch/$selenoprotein/genewise_TCOFFEE

t_coffee ./Llibreria_selenoproteins_$specie/${selenoprotein}.fa ./SelSearch/${selenoprotein}/genewise_proteina/${selenoprotein}.${scaf}.genewise.proteina.fa > ./SelSearch/$selenoprotein/genewise_TCOFFEE/"${selenoprotein}.${scaf}.aln"

mv *html ./SelSearch/$selenoprotein/genewise_proteina/
mv *aln ./SelSearch/$selenoprotein/genewise_proteina/

fi;

###NCBI_genewise

###Comparar el teu hit amb la NRdatabase per comporvar si existeix alguna proteina coneguda codificada dins els teu hit

echo -e "\033[1mComparant el hit resultant amb la base de dades no redundant d'NCBI.\033[0m"

mkdir -p ./SelSearch/$selenoprotein/NCBI

export PATH=/cursos/BI/bin/netblast/bin:$PATH
export PATH=/cursos/BI/bin/ncbiblast/bin:$PATH
cp /cursos/BI/bin/ncbiblast/.ncbirc ~/

blastall -p blastp -i "./SelSearch/$selenoprotein/genewise_proteina/${selenoprotein}.${scaf}.genewise.proteina.fa" -d /cursos/BI/soft/selenoprofiles_2_installation/libraries/nr -o ./SelSearch/$selenoprotein/NCBI/${selenoprotein}.${scaf}.ncbi

echo
echo -e "\033[1mFI.Esperem que que el programa hagi funcionat correctament i hagis pogut anotar la selenoproteïna en el genoma de C.picta bellii\033[0m"
echo 

echo
echo -e "\033[1mIMPORTANT! Recorda que pots guardar tots els resultats obtinguts dins el directori de la selenoproteina anotada en un altre directori de l'ordinador. T'aconsellem que copiis directament el directori en un directori extern en el shell personal de l'usuari que s'anomeni $selenoprotein_$scafold_$especie. Un cop et trobis dins el directori, pots copiar els resultats utilitzant aquesta comanda desde EL SHELL DEL VOSTRE ORDINADOR:( $scp U63739@luke.upf.edu:/homes/users/U63738/Treball_BI/SelSearch/$selenoprotein .) Moltes gràcies!\033[0m"
echo
 

